#include <stdio.h>
#include <stdlib.h>
#include "sungjin.h"
#include "dowoon.h"

static int N, M, W, Q, Land;
static int Rs[2020202], Cs[2020202], dirs[2020202];

static void my_assert(int TF, const char* message){
	if(!TF){ puts(message); exit(1); }
}

static int call_cnt = 0;
int Ask(int R1, int C1, int R2, int C2){
	call_cnt++;
	my_assert(call_cnt <= 2*N*M, "Wrong : Too Much Calls");
	my_assert(R1 >= 1 && R1 <= N && C1 >= 1 && C1 <= M, "Wrong : Invalid R, C");
	my_assert(R2 >= 1 && R2 <= N && C2 >= 1 && C2 <= M, "Wrong : Invalid R, C");
	my_assert(R1 != R2 || C1 != C2, "Wrong : Invalid R, C");

	return WereSameTerritory(R1, C1, R2, C2);
}

int main(){
	my_assert(scanf("%d%d%d", &N, &M, &W) == 3, "Error: Invalid Input");
	my_assert(2 <= N && N <= 1000, "Error: Invalid Input");
	my_assert(2 <= M && M <= 1000, "Error: Invalid Input");
	my_assert(0 <= W && W <= 2*N*M+N+M, "Error: Invalid Input");

	for(int i=0; i<W; i++){
		my_assert(scanf("%d%d%d", &Rs[i], &Cs[i], &dirs[i]) == 3, "Error: Invalid Input");
		my_assert(Rs[i] >= 1 && Rs[i] <= N && Cs[i] >= 1 && Cs[i] <= M, "Error: Invalid Input");
		my_assert(dirs[i] >= 1 && dirs[i] <= 4, "Error: Invalid Input");
	}
	Init(N, M, W, Rs, Cs, dirs);

	my_assert(scanf("%d", &Q) == 1, "Error: Invalid Input");
	my_assert(0 <= Q && Q <= 100000, "Error: Invalid Input");
	for(int i=Q; i--;){
		int R1, C1, R2, C2, ans;
		my_assert(scanf("%d%d%d%d%d", &R1, &C1, &R2, &C2, &ans) == 5, "Error: Invalid Input");
		my_assert(R1 >= 1 && R1 <= N && C1 >= 1 && C1 <= M, "Error: Invalid Input");
		my_assert(R2 >= 1 && R2 <= N && C2 >= 1 && C2 <= M, "Error: Invalid Input");
		my_assert(ans == 0 || ans == 1, "Error: Invalid Input");
		my_assert(WereSameTerritory(R1, C1, R2, C2) == ans, "Wrong : Sungjin is Wrong");
	}
	my_assert(scanf("%d", &Land) == 1, "Error: Invalid Input");
	puts("Sungjin does Correct!");

	int dwans = Guess(N, M);
	my_assert((Land*2 > N*M) == dwans, "Wrong : Dowoon is Wrong");
	printf("Dowoon does Correct!\n%d\n", call_cnt);
	return 0;
}
